/*****************************************************************************
 *      $Id: uname.c,v 1.1 1996/05/05 13:54:13 kanaya Exp $
 *****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <machine/sysnews.h>
#include <sys/utsname.h>

int
uname(name)
	struct utsname *name;
{
	struct machtype machtype_buf;
	char news_version[256], str[256];

	if (name == NULL) {
		errno = EINVAL;
		return -1;
	}

	if (gethostname(name->nodename, sizeof(name->nodename)) == -1) {
		return -1;
        }

	if (sysnews(NEWS_VERSION, news_version, sizeof(news_version)) == -1) {
		return -1;
	}

	if (sscanf(news_version, "%s Release %[^:]", name->sysname, str) != 2) {
		return -1;
	} else {
		char *p;

		if ((p = strrchr(str, '#')) == NULL) {
                        return -1;
		}
		strcpy(name->version, p);
		*(--p) = '\0';
		strcpy(name->release, str);
	}

	if (sysnews(NEWS_MACHTYPE, &machtype_buf) == -1) {
		return -1;
	}

	strcpy(name->machine, machtype_buf.mt_machine);

        return 0;
}
